
#include "pw/core/debug.hpp"
#include "pw/visual/pipeline.hpp"
#include "pw/visual/shader.hpp"

#include "runtime_lua.hpp"

namespace pw {

void register_visual_function(sol::state&,sol::table &ns)
{

	ns.new_usertype<pipeline>("pipeline"
							  ,"create",&pipeline::create
							  ,"draw",&pipeline::draw
                              );



	ns.new_usertype<shader>("shader"
                            ,sol::constructors<shader()>()
							,"ready",sol::readonly_property(&shader::ready)
							,"use",&shader::use
                            ,"build",&shader::build
                            ,"source",&shader::source
                            ,"set_source",&shader::set_source
                            ,"set_uniforms",&shader::set_uniforms
                            ).new_enum<false>("shader_type"
                                       ,"fragment",shader::code_type::fragment
                                       ,"vertex",shader::code_type::vertex
                                       ,"geometry",shader::code_type::geometry
                                       ,"compute",shader::code_type::compute);


    ns.new_usertype<render_pass>("render_pass"
                                ,"submit",&render_pass::submit
                                 );

    ns.new_usertype<material>("material"
                              ,"color",sol::property(&material::_color));


    ns.new_usertype<mesh_renderer>("mesh_renderer");
}

PW_REGISTER_LUA(visual)

}
