#ifndef PW_VISUAL_MESH_RENDERER_HPP
#define PW_VISUAL_MESH_RENDERER_HPP

#include <pw/core/matrix.hpp>

#include <map>

namespace pw {

class geometry;

/**
 * @brief Connects mesh data with the render backend
 */
class mesh_renderer {
public:
    mesh_renderer();
    mesh_renderer(const geometry& m);

    ~mesh_renderer();

	void create(const geometry &m);
	void release();

	void draw();
	bool ready() const;

protected:

	struct impl;
	std::unique_ptr<impl> _impl;

};

}

#endif
